
platform.apiLevel = '1.0'
bookl=book:len()
winh=212--platform.window:height()
winw=318--platform.window:width()
fontsize=10
vertspace=5
curPos=1
hoffset=5
voffset=0
firstline=true
firstLineOffset=platform.gc():getStringWidth("     ")
pbh=12
window=platform.window
deb=""
nextpage=0

function search()
	local searchString = var.recall("s")
	if(searchString ~= nil) then
		local curPos = var.recall("curPos")
		if(curPos == nil) then
			curPos = 0
		end
		local index = string.find(book, searchString, curPos)
		if(index ~= nil) then
			var.store("curPos", index)
		end
	end
end

function lastchar(str)
	return str:sub(str:len(),str:len())
end

function nextword(start)
	pos=string.find(book,"%s",start)
	return string.sub(book,start,pos)
end

function getline(gc,pos)
	local line2=""
	local line=""
	if (firstline) or (pos==1) then
		x=hoffset+firstLineOffset
		firstline=false
	end
	while (gc:getStringWidth(line2)+x<winw) do
		line=line2
		nw=nextword(pos)
		pos=pos+nw:len()
		line2=line..nw
		if (gc:getStringWidth(nw)+x>winw) then
			return line2
		end
		if (pos>=bookl) then
			return line2 
		end
		if (lastchar(line2)=="\010" and gc:getStringWidth(line2)+x<winw) then
			firstline=true
			return string.sub(line2, 0, string.len(line2)-1).." "
		end
	end
	return line
end

function getpage(gc,pos,display)
	--deb=deb.." i:"..pos
	local pos = pos
	display=display or false	-- default argument
	--deb=deb.."h:"
	while (y+fontsize+pbh<=winh) and (pos<=bookl) do
		--deb=deb..y+fontsize+pbh.." "
		line=getline(gc,pos)
		if (pos==1) then
			x=hoffset+firstLineOffset
		end
		pos=pos+line:len()
		--deb=deb..pos.." "
		if display then gc:drawString(line,x,y,"top") end
		x=hoffset	-- reset x
		y=y+fontsize+vertspace
	end
	--deb=deb.." getpage:"..pos
	return pos
end

function displayPage(gc)
	x=hoffset
	y=voffset
	h=0
	local p=curPos
	nextpage=getpage(gc,p,true)
end

function on.paint(gc)
		if(var.recall("curPos") ~= nil) then
			curPos = var.recall("curPos")
		end
	if(fontsize == nil) then fontsize = 10 end
	gc:setFont("sansserif","r",fontsize)
	gc:setColorRGB(0,0,0)
	--display page
	x=hoffset
	y=voffset
	h=0
	local pos = curPos
	while (y+fontsize+pbh<=winh) and (pos<=bookl) do
		--deb=deb..y+fontsize+pbh.." "
		line=getline(gc,pos)
		if (pos==1) then
			x=hoffset+firstLineOffset
		end
		pos=pos+line:len()
		--deb=deb..pos.." "
		gc:drawString(line,x,y,"top")
		x=hoffset	-- reset x
		y=y+fontsize+vertspace
	end
		--gc:drawString(y..','..fontsize..','..pbh..','..winh,5,0,"top")
	nextpage = pos
	gc:drawRect(0, winh-pbh, winw, pbh)
	gc:fillRect(0, winh-pbh, winw*nextpage/bookl, pbh);
	
	gc:setColorRGB(128,128,128)
	gc:setFont("sansserif","r", 6)
	position = "Page "..math.floor(nextpage/20.48)/100 .." of "..math.floor(bookl/20.48)/100
	gc:drawString(position, winw/2-gc:getStringWidth(position)/2, winh-pbh-1, "top")
end

function on.arrowRight()
	curPos=nextpage
	var.store("curPos", curPos)
	var.store("fontsize", fontsize)
	platform.window:invalidate()
end

function findBackward(str, char, pos)
	local str = str
	local pos = pos
	while (str:sub(pos,pos)~=char) and (pos>0) do
		pos=pos-1
	end
	var.store("curPos", pos)
	var.store("fontsize", fontsize)
	return pos
end

function getPreviousPage(gc, pos)
	x=hoffset
	y=voffset
	h=0
	deb=""
	local pos=pos
	local postest = findBackward(book, "\010", curPos-2)
	-- get first paragraph before previous page
	while (getpage(gc, postest, false) >= pos) do	-- find latest paragraph before current pos
		postest = findBackward(book, "\010", postest-2)
	end
	--while (getpage(gc, postest, false) < pos) do	-- display, check if before pos
		-- go through each previous newline
		--postest = postest + getline(gc, postest):len()
	--end
	-- go through each line
		-- check if end>=pos
	firstline=true
	--deb = gc:getStringWidth("    ")
	deb=deb.."("..postest..","..getline(gc, postest):len()..")"
	return postest+1
end

function on.arrowLeft()
	curPos=getPreviousPage(platform:gc(), curPos)
	platform.window:invalidate()
end

function on.charIn(ch)
	if(ch=="+") then fontsize=fontsize+1 end
	if(ch=="-") then fontsize=fontsize-1 end
	if(fontsize>18) then fontsize=18 end
	if(fontsize<6) then fontsize=6 end
	if     (ch == '4') then on.arrowLeft()
	elseif (ch == '6') then on.arrowRight()
	elseif (ch == 'f') then search()
	else
	end
	platform.window:invalidate()
end

function on.resize(width, height)
	on.create()
end

function on.create()
	winh=platform.window:height()
	winw=platform.window:width()
end

function on.restore(state)
	if(state[1] ~= nil and state[2] ~= nil) then
		curPos = state.position
		fontsize = state.fontsize
	else
		if(var.recall("curPos") ~= nil and var.recall("fontsize") ~= nil) then
			curPos = var.recall("curPos")
			--fontsize = var.recall("fontsize")
		else
			curPos = 0
			fontsize = 10
		end
	end
end

function on.save()
	state = {curPos, fontsize}
	var.store("curPos", curPos)
	var.store("fontsize", fontsize)
	return state
end